/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gUsesPopup;
var gDoc;
var gWindow;

var gLifeTime=2;
var abURI=null;
var ioService=Components.classes["@mozilla.org/network/io-service;1"]
               .getService(Components.interfaces.nsIIOService);

var gMabFiles;
var mabName;
var mabFile;
var oldRemoteFileName;
var warn=0;
var usePost=false;

var strings;
var syncing;
var externalApp;
var externalAppHandler;

var cleanUp=null;
var gAbort=0;

var gForce;
var gCheckLastMod=true;

function downloadDone() {
//alert('app='+externalApp+' handler='+externalAppHandler);
  if (externalApp) {
    syncprotocol = pref.getCharPref("extensions.addressbookssync.protocol");
    if (externalApp==-1)
      pref.clearUserPref("network.protocol-handler.external."+syncprotocol);
    else
      pref.setBoolPref("network.protocol-handler.external."+syncprotocol, true);
  }
  if (externalAppHandler)
    pref.setCharPref("network.protocol-handler.app."+syncprotocol, externalAppHandler);
  externalApp=null;
  externalAppHandler=null;
//TODO: appstarttime auf aktuelle zeit setzen?
}

//TODO: welche Addressbcher sind auf dem Server zu finden!?
function download(singleBook, force)
{
dump('in download appstart='+gAddressbooksSync.appstarttime+' state='+gAddressbooksSync.state+'\n');

  gForce=force||gAddressbooksSync.forceDownload;
    gAddressbooksSync.forceDownload=false;
  gCheckLastMod = gAddressbooksSync.checkLastModTime;
  var synctype=gAddressbooksSync.synctype;

  syncing=true;
  gUsesPopup=window.location=='chrome://addressbookssync/content/download.xul';
  strings = document.getElementById("strings");

  gAddressbooksSync.count=0;
  gMabFiles=(singleBook ? new Array(singleBook) : syncedAddressbooks('down'));

  if (synctype=='local') {
    gTempName='abstemp.mab';
    setTimeout(getLocalData, 0);  // need time to show the popup
  } else if (synctype=='remote') {
    gTempName='abstemp.mab';
    abURI=getSyncURI(false);
    try{ syncprotocol = pref.getCharPref( "extensions.addressbookssync.protocol" ); }
      catch(e){ killMe();}
    try { externalApp=pref.getBoolPref("network.protocol-handler.external."+syncprotocol); }
      catch(e) { externalApp=-1; }
    if (externalApp) pref.setBoolPref("network.protocol-handler.external."+syncprotocol, false);
    //ubuntu seems to ignore the value of external.xxx, therefore: 
    try {
      externalAppHandler=pref.getCharPref("network.protocol-handler.app."+syncprotocol);
      if (externalAppHandler) pref.clearUserPref("network.protocol-handler.app."+syncprotocol);
    } catch(e) { externalAppHandler=''; }
    cleanUp=downloadDone;
    oldRemoteFileName='';
    try { usePost=pref.getBoolPref("extensions.addressbookssync.usepost"); }
      catch(e) { usePost=false; }
    setTimeout(getData, 0);
  } else if (synctype=='imap') {
    setTimeout(imapLoad, 0);
  } else {
    killMe();
  }
}

function getLocalData() {
  var localpath=pref.getCharPref( "extensions.addressbookssync.localpath" )
  if (localpath) {
    var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    dir.initWithPath( localpath );
    for (var i = 0; i < gMabFiles.length; i++) {
      if (gAbort) break;
      var mabFile=gMabFiles[i];
      var cur=getAddressBook(mabFile);
      var mabName=cur.directoryProperties.description;
      var uri = cur.directoryProperties.URI;

      if (gAddressbooksSync.appstarttime<getLastModified(cur)) {
        if (!confirm(mabName+': '+strings.getString('askmodified'))) {
          statustxt("download "+mabName+" "+strings.getString('skipped'), true, false);  // 1. dot: start
          continue;
        }
      }

      var localFileName;
      var oldLocalFileName;
      if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI) {
        localFileName = mabName+'.mab'; //ex: =mabFile
        oldLocalFileName = localFileName==mabFile?'':mabFile;
      } else {
        localFileName = '_tb_'+cur.directoryProperties.fileName;
        oldLocalFileName = mabFile;
      }

      statustxt(mabName+'..', true, false);
      ret=loadMabFile(mabName, mabFile, dir, localFileName, oldLocalFileName, gForce, gCheckLastMod);
      if (ret=='copied') {
        statustxt(strings.getString('copied'), false, false);
        gAddressbooksSync.count+=1;
      } else if (ret=='notcopied')
        statustxt(strings.getString('notcopied'), false, true);
      else
        statustxt(strings.getString('skipped'), false, true);
    }
  }
  killMe();
}

function getData()
{
  if (gAbort) {
    killMe();
    return;
  }
  if (!checkOffline('download')) return;

  if (!oldRemoteFileName) {
//    while (true) {
      mabFile=gMabFiles.pop();
      if (!mabFile) {
        if (warn) gLifeTime=5;//a little bit longer
        killMe();
        return;
      }
//      if (mabFile!='!') break;  // mabFile is '!', if its modified and should not be overwritten
//   }
    var cur=getAddressBook(mabFile);
    mabName=cur.directoryProperties.description;
    var uri = cur.directoryProperties.URI;

    if (gAddressbooksSync.appstarttime<getLastModified(cur)) {
      if (!confirm(mabName+': '+strings.getString('askmodified'))) {
        statustxt("download "+mabName+" "+strings.getString('skipped'), true, false);
        getData();
        return;
      }
    }

    var remoteFileName;
    if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI) {
      remoteFileName = mabName+".mab";
      oldRemoteFileName='';
    } else {
      remoteFileName = '_tb_'+cur.directoryProperties.fileName;
      oldRemoteFileName=mabName+".mab";
    }
    statustxt("download "+mabName+".", true, false);  // 1. dot: start
  } else {
    remoteFileName=oldRemoteFileName;
    oldRemoteFileName = '';
  }

  var mabURI=abURI+remoteFileName;
  var URI=ioService.newURI(mabURI,null,null);

/*
  var protService=Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
               .getService(Components.interfaces.nsIExternalProtocolService);
  //Windows: from Registry HKCR\ftp\shell\open\command
  //Unix:    form preferences network.protocol-handler.app.
  if (protService.externalProtocolHandlerExists(URI.scheme)) {
    alert('external Protocol handler for '+URI.scheme+': '+
      protService.getApplicationDescription(URI.scheme));
  }
*/

  statustxt(".", false, false); // 2. dot: start of download

  var flmt=null;
  if (!gForce && gCheckLastMod) {
    //check for last modified date on download
    var localMabFile = getDir('ProfD');
    localMabFile.appendRelativePath( mabFile );
    var flmt=new Date(localMabFile.lastModifiedTime);
  }
  var error=gBookmarksSynchronizerDownloadService.start(URI, downloadCallback, usePost, flmt);
  if(error)
    downloadCallback("done", error);
  else
    statustxt(".", false, false); // 3. dot: download started
}

function downloadCallback(aStatus,aError)
{
  if(aStatus != "done" && aError==0)
    return;

  switch(aError){
    case -2:
      return;
      break;
    case 0:
      statustxt(".", false, false); // 4. dot: download complete
      try{
        var abData=gBookmarksSynchronizerDownloadService.data;
        //Data must start with: // <!-- <mdb:mork:z v="1.4"/> --> otherwise its an HTML error page
        if (abData.substr( 0, 19 )=='// <!-- <mdb:mork:z') {
          oldRemoteFileName=''; // stop retry loop

/*
          if (!gForce && gCheckLastMod) {
            //extract lastModifiedDate from mork line
            var matches=abData.match(/-->\s?([^\r\n]*)/);
            var rlmt=new Date(matches[1]);
            var localMabFile = getDir('ProfD');
            localMabFile.appendRelativePath( mabFile );
            var flmt=new Date(localMabFile.lastModifiedTime);
            if (rlmt<=flmt) {
              statustxt(strings.getString('skipped'), false, false);
              break;
            }
          }
*/

          var nsITmpFile = getDir('TmpD');
          nsITmpFile.appendRelativePath( gTempName );
          //file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
          writeMabData(nsITmpFile, abData);
          statustxt(".", false, false); // 5. dot: file written
          var err=replaceAddressBook(mabName, mabFile, nsITmpFile);
          if (err) {
            statustxt(err, false, false);
            break;
          }
          statustxt(strings.getString('ok'), false, false);
          gAddressbooksSync.count+=1;
          gWindow.abs_init(); // update options list, if necessary
        } else {    //try to extract error message from <title> tag
          if (!oldRemoteFileName) { // probably check for '404'
            if(abData.match(/<title>(\d+).*<\/title>/i))
              statustxt(errorstr(RegExp.$1), false, true);
            else
              statustxt(strings.getString('failed'), false, true);
            warn=1;
          }
        }
      } catch(e) {
        if(e && e.toString().match(/^absync\:(.+)$/))
          statustxt(RegExp.$1, false, true);
      }
      break;
    case 0x804b0002: // NS_BINDING_ABORTED: Download stopped because of timecheck
      statustxt(strings.getString('skipped'), false, false);
      break;
    default:
      //0x804b0016 is FTPs 'no such file'
      if (aError!=0x804b0016 || !oldRemoteFileName) {
        statustxt(errorstr(aError), false, true);
        oldRemoteFileName='';
  //      gLifeTime=5;
  //      killMe();
      }
      break;
  }
  if (gUsesPopup) getData();  // next addressbook
  else setTimeout(getData, 1000);
}

function cancelDownload()
{
  if (gAbort) {
    gAbort++;
    killMe();
  } else {
    gAbort++;
    document.getElementById("abs_cancel").label='kill';
  }
  //gBookmarksSynchronizerDownloadService.cancel(); //No, or we may left behind with corrupt mabs
}


